; ADAM boot block
; This boot block initialises the VDP and loads 32 blocks at address $0100
; Copyright (C)  Marcel de Kogel 1996,1997
; You are not allowed to distribute this software commercially
; Please, notify me if you make any changes to this file

WriteVDP                equ     $FD20
SetTable                equ     $FD29
ReadVDPStatus           equ     $FD23
LoadASCII               equ     $FD38
ConsoleOutput           equ     $FC39
InitConsole             equ     $FC36
FillVRAM                equ     $FD26

ReadBlock               equ     $FCF3

        code
        org     $C800

        ld      a,b
        ld      (OurDevice),a
        ld      hl,LowerRAM
        ld      de,$0000
        ld      bc,$0100
        ldir
        ld      bc,$0180
        call    WriteVDP
        ld      bc,$0000
        call    WriteVDP
        ld      bc,$07F2
        call    WriteVDP
        ld      a,0
        ld      hl,$3900
        call    SetTable
        ld      a,1
        ld      hl,$3800
        call    SetTable
        ld      a,2
        ld      hl,$0000
        call    SetTable
        ld      a,3
        ld      hl,$0800
        call    SetTable
        ld      a,4
        ld      hl,$03C0
        call    SetTable
        ld      bc,$01E0
        call    WriteVDP
        call    ReadVDPStatus
        call    LoadASCII
        ld      b,30
        ld      c,23
        ld      d,1
        ld      e,0
        ld      hl,0
        call    InitConsole
        ld      a,$F0
        ld      de,$60
        ld      hl,$3C0
        call    FillVRAM
        ld      hl,Welcome
        call    PrintString
        call    LoadProgram
        ld      hl,NewLine
        call    PrintString
        ld      hl,(Address)
        jp      (hl)

PrintString:
        ld      a,(hl)
        cp      $0
        ret     z
        call    ConsoleOutput
        inc     hl
        jr      PrintString

ReadOneBlock:
        ld      a,(OurDevice)
        push    bc
        push    de
        push    hl
        ld      bc,0
        call    ReadBlock
        pop     hl
        pop     de
        pop     bc
        ret

LoadProgram:
        ld      de,(StartBlock)
        ld      hl,(Address)
        ld      bc,(NumBlocks)
LoadProgram_Loop:
        call    ReadOneBlock
        jr      nz,LoadProgram_Loop
        inc     de
        push    de
        ld      de,1024
        add     hl,de
        pop     de
        dec     bc
        ld      a,c
        or      b
        jr      nz,LoadProgram_Loop
        ret

Welcome:        db      "One moment please...",0
NewLine:        db      13,10,0

OurDevice       db      0
StartBlock      dw      1
NumBlocks       dw      32
Address         dw      $0100

        org     $CB00

LowerRAM        db      0
        org     $CB38
                reti
        org     $CB66
                push    af
                push    bc
                push    de
                push    hl
                call    ReadVDPStatus
                pop     hl
                pop     de
                pop     bc
                pop     af
                retn
        org     $CBFF
                db      $FF

        end
