; ADAMEm tape converter
; This program copies the contents of a tape to two diskettes
; Copyright (C)  Marcel de Kogel 1996,1997
; You are not allowed to distribute this software commercially
; Please, notify me if you make any changes to this file

WriteVDP                equ     $FD20
SetTable                equ     $FD29
ReadVDPStatus           equ     $FD23
LoadASCII               equ     $FD38
ConsoleOutput           equ     $FC39
InitConsole             equ     $FC36
FillVRAM                equ     $FD26

ReadBlock               equ     $FCF3
WriteBlock              equ     $FCF6

ReadKeyboard            equ     $FC6C

        code
        org     $100

        ld      hl,Hallo
        call    PrintString
start:
        ld      hl,SourceReq
        call    PrintString
loop1:  call    ReadKeyboard
        cp      $31
        jr      z,tape1
        cp      $32
        jr      nz,loop1
        ld      a,24
        jr      tape_done
tape1:  ld      a,8
tape_done:
        ld      (SourceDev),a
        ld      hl,DestReq
        call    PrintString
loop2:  call    ReadKeyboard
        cp      $31
        jr      z,disk1
        cp      $32
        jr      nz,loop2
        ld      a,5
        jr      disk_done
disk1:  ld      a,4
disk_done:
        ld      (DestDev),a
        ld      hl,WaitMessage
        call    PrintString
wait:   call    ReadKeyboard
        cp      $20
        jr      nz,wait
        ld      hl,CopyMessage
        call    PrintString
        ld      e,0
        ld      b,8
mainloop1:
        call    read_16_blocks
        call    write_16_blocks
        ld      a,e
        add     a,16
        ld      e,a
        djnz    mainloop1
        ld      hl,NewLine
        call    PrintString
        ld      hl,ChangeMessage
        call    PrintString
change: call    ReadKeyboard
        cp      $20
        jr      nz,change
        ld      hl,CopyMessage
        call    PrintString
        ld      e,128
        ld      b,8
mainloop2:
        call    read_16_blocks
        call    write_16_blocks
        ld      a,e
        add     a,16
        ld      e,a
        djnz    mainloop2
        ld      hl,NewLine
        call    PrintString
        ld      hl,DoneMessage
        call    PrintString
        jp      start

PrintString:
        ld      a,(hl)
        cp      $0
        ret     z
        call    ConsoleOutput
        inc     hl
        jr      PrintString

read_16_blocks:
        push    bc
        push    de
        ld      b,16
        ld      hl,Buffer
read_16_loop:
        call    PrintBlockNr
        call    ReadOneBlock
        inc     h
        inc     h
        inc     h
        inc     h
        inc     e
        djnz    read_16_loop
        pop     de
        pop     bc
        ret

write_16_blocks:
        push    bc
        push    de
        ld      b,16
        ld      hl,Buffer
write_16_loop:
        call    PrintBlockNr
        push    de
        ld      a,e
        and     127
        ld      e,a
        call    WriteOneBlock
        pop     de
        inc     e
        inc     h
        inc     h
        inc     h
        inc     h
        djnz    write_16_loop
        pop     de
        pop     bc
        ret

hex2ascii       db      "0123456789ABCDEF"

PrintBlockNr:
        push    bc
        push    de
        push    hl
        ld      a,8
        call    ConsoleOutput
        ld      a,8
        call    ConsoleOutput
        ld      a,e
        push    af
        and     $F0
        rr      a
        rr      a
        rr      a
        rr      a
        ld      hl,hex2ascii
        ld      e,a
        ld      d,0
        add     hl,de
        ld      a,(hl)
        call    ConsoleOutput
        pop     af
        and     $0F
        ld      hl,hex2ascii
        ld      e,a
        ld      d,0
        add     hl,de
        ld      a,(hl)
        call    ConsoleOutput
        pop     hl
        pop     de
        pop     bc
        ret

ReadOneBlock:
        push    bc
        push    de
        push    hl
        ld      d,0
        ld      bc,0
        ld      a,(SourceDev)
        call    ReadBlock
        call    nz,PrintReadError
        pop     hl
        pop     de
        pop     bc
        ret

WriteOneBlock:
        push    bc
        push    de
        push    hl
        ld      d,0
        ld      bc,0
        ld      a,(DestDev)
        call    WriteBlock
        call    nz,PrintWriteError
        pop     hl
        pop     de
        pop     bc
        ret

PrintReadError:
        push    bc
        push    de
        push    hl
        ld      hl,ReadError
        ld      d,0
        jr      PrintErrorCommon
PrintWriteError:
        push    bc
        push    de
        push    hl
        ld      hl,WriteError
        ld      d,$80
PrintErrorCommon:
        push    de
        call    PrintString
        ld      hl,NewLine
        call    PrintString
        pop     de
        ld      a,e
        and     $7f
        or      d
        cp      $ff
        ld      hl,CopyMessage
        call    nz,PrintString
        pop     hl
        pop     de
        pop     bc
        ret

Hallo           db      "ADAMEm tape converter",13,10
                db      "Copyright (C) M. de Kogel 1996",13,10,13,10,0
SourceReq       db      "Please select the source:",13,10
                db      "1 - Tape drive A",13,10
                db      "2 - Tape drive B",13,10,0
DestReq         db      "Please select the destination:",13,10
                db      "1 - Disk drive A",13,10
                db      "2 - Disk drive B",13,10,0
WaitMessage     db      "Please make sure the correct",13,10
                db      "disk and tape are in the",13,10
                db      "drives and press the spacebar",13,10,0
ChangeMessage   db      "Please put the second disk in",13,10
                db      "the drive and press the",13,10
                db      "spacebar",13,10,0
CopyMessage     db      "Block   ",0
ReadError       db      " - READ ERROR",0
WriteError      db      " - WRITE ERROR",0
DoneMessage     db      "Done",13,10,13,10,0
NewLine         db      13,10,0

SourceDev       db      0
DestDev         db      0

Buffer

                org     $100+31*1024-1
                db      $ff

                end
